searchNodes=[{"type":"module","title":"tls_certificate_check","doc":"Main API","ref":"tls_certificate_check.html"},{"type":"function","title":"tls_certificate_check.options/1","doc":"Returns the list of ssl:connect options necessary to validate the server certificate against a list of trusted authorities, as well as to verify whether the server hostname matches one in the server certificate. Target can be either a hostname or an HTTP URL, as iodata()","ref":"tls_certificate_check.html#options/1"},{"type":"function","title":"tls_certificate_check.override_trusted_authorities/1","doc":"Overrides the trusted authorities with a custom source.","ref":"tls_certificate_check.html#override_trusted_authorities/1"},{"type":"function","title":"tls_certificate_check.trusted_authorities/0","doc":"Returns the list of trusted authorities.","ref":"tls_certificate_check.html#trusted_authorities/0"},{"type":"type","title":"tls_certificate_check.option/0","doc":"","ref":"tls_certificate_check.html#t:option/0"},{"type":"type","title":"tls_certificate_check.override_source/0","doc":"","ref":"tls_certificate_check.html#t:override_source/0"},{"type":"extras","title":"tls_certificate_check","doc":"tls_certificate_check is a library for Erlang/OTP and Elixir that tries to make it easier to establish more secure HTTPS connections in ordinary setups. Other kinds of TLS/SSL connections may also benefit from it. It blends a CA trust store with ssl_verify_fun to verify remote hostnames, as well as the boilerplate to validate misordered certificate chains . The OTP-trusted CAs (typically provided by the OS) are used on OTP 25+ unless unavailable or opted-out[^1], in which case tls_certificate_check falls back to a hardcoded Mozilla's CA certificate store , as extracted by curl . When on OTP 24 or older, the lib will initialize using only the latter. The trusted authorities' certificates are loaded when the application starts and made available to the API through persistent_term [^2]. After that, they can be explicitly overridden through the API. Usage - Erlang 1. Import as a dependency rebar.config { deps , [ % [...] { tls_certificate_check , &quot;~&gt; 1.22&quot; } ] } . your_application.app.src { applications , [ kernel , stdlib , % [...] tls_certificate_check ] } 2. Make your connections safer Host = &quot;example.com&quot; , Options = tls_certificate_check : options ( Host ) , ssl : connect ( Host , 443 , Options , 5000 ) Usage - Elixir 1. Import as a dependency mix.exs defp deps do [ # [...] { :tls_certificate_check , &quot;~&gt; 1.22&quot; } ] end 2. Make your connections safer host = &quot;example.com&quot; options = :tls_certificate_check . options ( host ) host |&gt; String . to_charlist ( ) |&gt; :ssl . connect ( 443 , options , 5000 ) Advanced Usage Overriding Trusted CAs Erlang Path = certifi : cacertfile ( ) , tls_certificate_check : override_trusted_authorities ( { file , Path } ) Elixir path = CAStore . file_path ( ) :tls_certificate_check . override_trusted_authorities ( { :file , path } ) API Reference The API reference can be found on HexDocs . Tested setup Erlang/OTP 22 or newer rebar3 License MIT License Copyright (c) 2020-2024 Guilherme Andrade Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. [^1]: the use of OTP-trusted CAs can be controlled through the use_otp_trusted_CAs boolean option within application env config. [^2]: the persistent term key is derived from the CA store's own contents and existing keys are not erased until the app terminates gracefully - this minimizes the risk of an impactful global garbage collection.","ref":"readme.html"},{"type":"extras","title":"Changelog","doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog and this project adheres to Semantic Versioning .","ref":"changelog.html"},{"type":"extras","title":"Changelog - [1.22.0] - 2024-03-16","doc":"Added [certificate authority] Telekom Security TLS ECC Root 2020 [certificate authority] Telekom Security TLS RSA Root 2023 OTP 26.2 to CI Changed module with bundled CAs to latest as of 2024/03/11, 15:25 UTC (source: https://curl.se/ca/cacert.pem ) Fixed Elixir example of how to use tls_certificate_check with ssl:connect/4 (thanks https://github.com/macifell )","ref":"changelog.html#1-22-0-2024-03-16"},{"type":"extras","title":"Changelog - [1.21.0] - 2023-12-12","doc":"Added [certificate authority] CommScope Public Trust ECC Root-01 [certificate authority] CommScope Public Trust ECC Root-02 [certificate authority] CommScope Public Trust RSA Root-01 [certificate authority] CommScope Public Trust RSA Root-02 [certificate authority] TrustAsia Global Root CA G3 [certificate authority] TrustAsia Global Root CA G4 OTP 26.1 to CI Changed module with bundled CAs to latest as of 2023/12/12, 04:12 UTC (source: https://curl.se/ca/cacert.pem ) Removed [certificate authority] Autoridad de Certificacion Firmaprofesional CIF A62634068 [certificate authority] security communication rootca1","ref":"changelog.html#1-21-0-2023-12-12"},{"type":"extras","title":"Changelog - [1.20.0] - 2023-08-22","doc":"Added [certificate authority] Atos TrustedRoot Root CA ECC TLS 2021 [certificate authority] Atos TrustedRoot Root CA RSA TLS 2021 [certificate authority] SSL.com TLS ECC Root CA 2022 [certificate authority] SSL.com TLS RSA Root CA 2022 [certificate authority] sectigo public server authentication root e46 [certificate authority] sectigo public server authentication root r46 Changed module with bundled CAs to latest as of 2023/08/22, 03:12 UTC (source: https://curl.se/ca/cacert.pem ) Removed [certificate authority] e-tugra global root ca ecc v3 [certificate authority] e-tugra global root ca rsa v3","ref":"changelog.html#1-20-0-2023-08-22"},{"type":"extras","title":"Changelog - [1.19.0] - 2023-05-30","doc":"Added OTP 26.0 to CI [certificate authority] BJCA Global Root CA2 [certificate authority] BJCA Global Root CA1 Changed CI to use latest rebar3 version that's compatible with each covered OTP release module with bundled CAs to latest as of 2023/05/30, 03:12 UTC (source: https://curl.se/ca/cacert.pem ) Removed [certificate authority] hongkong post root ca 1 [certificate authority] E-Tugra Certification Authority","ref":"changelog.html#1-19-0-2023-05-30"},{"type":"extras","title":"Changelog - [1.18.1] - 2023-05-01","doc":"Changed import of ssl_verify_fun to match latest allowed 1.x version Fixed failing tests and checks on macOS ventura (maybe ARM specific)","ref":"changelog.html#1-18-1-2023-05-01"},{"type":"extras","title":"Changelog - [1.18.0] - 2023-03-20","doc":"Added explicit SNI, to account for TCP sockets upgraded to ssl with ssl:connect/3 OTP 25.3 to CI Fixed CI deprecation warnings","ref":"changelog.html#1-18-0-2023-03-20"},{"type":"extras","title":"Changelog - [1.17.4] - 2023-02-19","doc":"Fixed error starting application when OS-trusted CAs fail to load on OTP 25 [present since 1.17.0]","ref":"changelog.html#1-17-4-2023-02-19"},{"type":"extras","title":"Changelog - [1.17.3] - 2023-01-17","doc":"Fixed (rare?) crash after reading OS-trusted CAs","ref":"changelog.html#1-17-3-2023-01-17"},{"type":"extras","title":"Changelog - [1.17.2] - 2023-01-12","doc":"Fixed listing of private modules and functions in generated reference","ref":"changelog.html#1-17-2-2023-01-12"},{"type":"extras","title":"Changelog - [1.17.1] - 2023-01-12","doc":"Fixed unreleased version in change log","ref":"changelog.html#1-17-1-2023-01-12"},{"type":"extras","title":"Changelog - [1.17.0] - 2023-01-11","doc":"Added ability to override trusted CAs Windows to CI OTP 25.2 to CI Changed default CAs to the ones trusted by OTP (typically provided by the OS), when available, on OTP 25+ shared state owner to not erase its persistent_term s when crashing module with bundled CAs to latest as of 2023/01/10, 04:12 UTC (source: https://curl.se/ca/cacert.pem ) Removed [certificate authority] network solutions certificate authority [certificate authority] TrustCor ECA-1 [certificate authority] TrustCor RootCert CA-1 [certificate authority] Staat der Nederlanden EV Root CA [certificate authority] TrustCor RootCert CA-2","ref":"changelog.html#1-17-0-2023-01-11"},{"type":"extras","title":"Changelog - [1.16.0] - 2022-10-11","doc":"Added OTP 25.1 to CI [certificate authority] security communication ecc rootca1 [certificate authority] security communication rootca3 Changed module with bundled CAs to latest as of 2022/10/11, 03:12 UTC (source: https://curl.se/ca/cacert.pem )","ref":"changelog.html#1-16-0-2022-10-11"},{"type":"extras","title":"Changelog - [1.15.0] - 2022-07-20","doc":"Added OTP 25 to CI [certificate authority] certainly root e1 [certificate authority] digicert tls ecc p384 root g5 [certificate authority] e-tugra global root ca ecc v3 [certificate authority] certainly root r1 [certificate authority] digicert tls rsa4096 root g5 [certificate authority] e-tugra global root ca rsa v3 Changed module with bundled CAs to latest as of 2022/07/19, 03:12 UTC (source: https://curl.se/ca/cacert.pem ) Removed [certificate authority] hellenic academic and research institutions rootca 2011 Fixed fragile automated CHANGELOG updates flaky test case","ref":"changelog.html#1-15-0-2022-07-20"},{"type":"extras","title":"Changelog - [1.14.0] - 2022-04-27","doc":"Added [certificate authority] d-trust ev root ca 1 2020 [certificate authority] d-trust br root ca 1 2020 [certificate authority] Telia Root CA v2 Changed module with bundled CAs to latest as of 2022/04/26, 03:12 UTC (source: https://curl.se/ca/cacert.pem )","ref":"changelog.html#1-14-0-2022-04-27"},{"type":"extras","title":"Changelog - [1.13.0] - 2022-03-18","doc":"Changed module with bundled CAs to latest as of 2022/03/18, 12:30 UTC (source: https://curl.se/ca/cacert.pem ) Removed [certificate authority] ec-acc","ref":"changelog.html#1-13-0-2022-03-18"},{"type":"extras","title":"Changelog - [1.12.0] - 2022-02-02","doc":"Added [certificate authority] vtrus ecc root ca [certificate authority] isrg root x2 [certificate authority] vtrus root ca [certificate authority] HiPKI Root CA - G1 [certificate authority] Autoridad de Certificacion Firmaprofesional CIF A62634068 Changed module with bundled CAs to latest as of 2022/02/01, 04:12 UTC (source: https://curl.se/ca/cacert.pem ) [certificate authority] gts root r4 [certificate authority] gts root r3 [certificate authority] gts root r1 [certificate authority] gts root r2 [certificate authority] GlobalSign ECC Root CA - R4 Removed [certificate authority] GlobalSign Root CA - R2 [certificate authority] cybertrust global root","ref":"changelog.html#1-12-0-2022-02-02"},{"type":"extras","title":"Changelog - [1.11.0] - 2021-10-28","doc":"Added [certificate authority] HARICA TLS ECC Root CA 2021 [certificate authority] HARICA TLS RSA Root CA 2021 [certificate authority] TunTrust Root CA Changed module with bundled CAs to latest as of 2021/10/26, 03:12 UTC (source: https://curl.se/ca/cacert.pem )","ref":"changelog.html#1-11-0-2021-10-28"},{"type":"extras","title":"Changelog - [1.10.0] - 2021-10-01","doc":"Changed module with bundled CAs to latest as of 2021/09/30, 21:42 UTC (source: https://curl.se/ca/cacert.pem ) Removed [certificate authority] dst root ca x3","ref":"changelog.html#1-10-0-2021-10-01"},{"type":"extras","title":"Changelog - [1.9.0] - 2021-09-03","doc":"Added test coverage of certificates yet-to-be valid test coverage of misordered certificate chains Changed partial chain validation to prepare for DST Root CA X3 expiration documentation from edoc to ExDoc Removed dependency on badssl.com for important test cases","ref":"changelog.html#1-9-0-2021-09-03"},{"type":"extras","title":"Changelog - [1.8.0] - 2021-08-31","doc":"Added automated PR-based update of bundled CAs through GHA Changed app description to tentatively improve it","ref":"changelog.html#1-8-0-2021-08-31"},{"type":"extras","title":"Changelog - [1.7.0] - 2021-07-08","doc":"Added [certificate authority] certum ec-384 ca [certificate authority] globaltrust 2020 [certificate authority] certum trusted root ca [certificate authority] anf secure server root ca Changed module with bundled CAs to latest as of 2021/07/05, 21:35 UTC (source: https://curl.se/ca/cacert.pem ) Removed [certificate authority] sonera class2 ca [certificate authority] trustis fps root ca [certificate authority] quovadis root certification authority","ref":"changelog.html#1-7-0-2021-07-08"},{"type":"extras","title":"Changelog - [1.6.0] - 2021-05-30","doc":"Changed module with bundled CAs to latest as of 2021/05/25, 03:12 UTC (source: https://curl.se/ca/cacert.pem ) Removed [certificate authority] global chambersign root - 2008 [certificate authority] chambers of commerce root - 2008","ref":"changelog.html#1-6-0-2021-05-30"},{"type":"extras","title":"Changelog - [1.5.0] - 2021-05-13","doc":"Added OTP 24 to CI targets Removed compatibility with OTP 21","ref":"changelog.html#1-5-0-2021-05-13"},{"type":"extras","title":"Changelog - [1.4.0] - 2021-04-16","doc":"Added [certificate authority] globalsign root e46 [certificate authority] AC RAIZ FNMT-RCM SERVIDORES SEGUROS [certificate authority] globalsign root r46 Changed module with bundled CAs to latest as of 2021/04/13, 03:12 UTC (source: https://curl.se/ca/cacert.pem ) Removed [certificate authority] geotrust primary certification authority - g2 [certificate authority] verisign universal root certification authority [certificate authority] Staat der Nederlanden Root CA - G3","ref":"changelog.html#1-4-0-2021-04-16"},{"type":"extras","title":"Changelog - [1.3.0] - 2021-04-02","doc":"Added tls_certificate_check:trusted_authorities/0 to API Changed list of authoritative certificates, from hardcoded to one that's generated on application boot and stored on persistent_term set of trusted public keys, from hardcoded to one that's generated on application boot and stored on persistent_term Removed compatibility with OTP 19 compatibility with OTP 20 compatibility with OTP 21.0 and 21.1 priv/cacerts.pem Fixed unwarranted and risky hardcoding of record values","ref":"changelog.html#1-3-0-2021-04-02"},{"type":"extras","title":"Changelog - [1.2.0] - 2021-03-12","doc":"Added elements for easily updating bundled CAs [certificate authority] NAVER Global Root Certification Authority Changed module with bundled CAs to latest as of 2021/01/19, 04:12 UTC (source: https://curl.se/ca/cacert.pem ) Removed [dependency] certifi [dependency] parse_trans [certificate authority] thawte primary root ca - g2 [certificate authority] geotrust global ca [certificate authority] geotrust primary certification authority [certificate authority] verisign class 3 public primary certification authority - g4 [certificate authority] geotrust primary certification authority - g3 [certificate authority] thawte primary root ca [certificate authority] thawte primary root ca - g3 [certificate authority] verisign class 3 public primary certification authority - g5 [certificate authority] geotrust universal ca [certificate authority] geotrust universal ca 2 Fixed misuse of tls_certificate_ namespace (all modules start with tls_certificate_check now)","ref":"changelog.html#1-2-0-2021-03-12"},{"type":"extras","title":"Changelog - [1.1.1] - 2020-12-08","doc":"Fixed compilation errors on OTP 20.1+ when on top of macOS Big Sur","ref":"changelog.html#1-1-1-2020-12-08"},{"type":"extras","title":"Changelog - [1.1.0] - 2020-12-05","doc":"Changed CA bundles, based on the latest mkcert.org full CA list as of Nov 13, 2020","ref":"changelog.html#1-1-0-2020-12-05"},{"type":"extras","title":"Changelog - [1.0.2] - 2020-10-16","doc":"Fixed misdetection of Mix as being rebar 2 and the erronous compilation warning that followed it","ref":"changelog.html#1-0-2-2020-10-16"},{"type":"extras","title":"Changelog - [1.0.1] - 2020-05-21","doc":"Fixed missing links to source code in application metadata","ref":"changelog.html#1-0-1-2020-05-21"},{"type":"extras","title":"Changelog - [1.0.0] - 2020-05-21","doc":"Added :options function to API, for easily securing connections","ref":"changelog.html#1-0-0-2020-05-21"},{"type":"extras","title":"LICENSE","doc":"MIT License Copyright (c) 2020-2024 Guilherme Andrade Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"}]